﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace SMTPServer
{
    class MTASession
    {
        private static MTACommandsDict MTACommandsDict = new MTACommandsDict();
        private ConnectedEventArgs ConnectedEventArgs { get; set; }

        private bool Initialized { get; set; }
        private string SenderHostname { get; set; }

        private bool AuthActive { get; set; }
        private string Username { get; set; }
        private string Password { get; set; }
        private bool Authenticated { get; set; }

        private bool DATA { get; set; }

        private string Mail_From { get; set; }

        public MTASession(ConnectedEventArgs e)
        {
            ConnectedEventArgs = e;
            Thread th = new Thread(new ThreadStart(StartCommunication));
            th.Start();
        }

        private void StartCommunication()
        {
            ConnectedEventArgs.SendResponse(ResponseCodes.C220, MailTransferAgent.Hostname);
            ConnectedEventArgs.NewLine += ConnectedEventArgs_NewLine;
        }

        private void ConnectedEventArgs_NewLine(string line)
        {
            if (line.StartsWith(MTACommandsDict[MTACommands.RSET]))
            {
                // Schauen was alles resettet wird
            }

            if (!Initialized)
            {
                if (line.StartsWith(MTACommandsDict[MTACommands.HELO]))
                {
                    ConnectedEventArgs.SendResponse(ResponseCodes.C250, MailTransferAgent.Hostname);
                    //} else if (line.StartsWith(MTACommandsDict[MTACommands.EHLO])) {
                    //    ConnectedEventArgs.SendResponse(ResponseCodes.C250, MailTransferAgent.Hostname);
                }
                else
                {
                    ConnectedEventArgs.SendResponse(ResponseCodes.C503, MailTransferAgent.Hostname);
                    return;
                }
                Initialized = true;
            }

            if (line.StartsWith(MTACommandsDict[MTACommands.AUTH_LOGIN]))
            {
                AuthActive = true;
                ConnectedEventArgs.SendResponse(ResponseCodes.C334);
            }
            else if (line.StartsWith(MTACommandsDict[MTACommands.MAIL_FROM]))
            {
                var args = line.Split(':');
                if (args.Length < 2)
                {
                    ConnectedEventArgs.SendResponse(ResponseCodes.C501);
                    return;
                }
                var mailFrom = args[1];
                mailFrom.Replace('<', ' ');
            }
            else if (line.StartsWith(MTACommandsDict[MTACommands.QUIT]))
            {
                //throw new NotImplementedException();
            } else
            {
                ConnectedEventArgs.SendResponse(ResponseCodes.C500);
            }
        }
    }
}
